#ifndef _DATA_H_
#define _DATA_H_

#include <data_type.h>

/*
 * some inital typedefs
 */
struct data_type;
struct data_set;
struct data_core;
typedef struct data_type *data_type_t;
typedef struct data_set *data_set_t;
typedef struct data_core *data_core_t;

/*
 * List of possible operations:
 */
#define	D_RETVAL	0x0100	/* return value, not ptr to value */
#define D_PARAMPTR	0x0200	/* first param is ptr to area to store val */

				/* #param, #return */
#define	D_NONE		0
#define	D_INIT		1	/* 0, 0 */	/* initalize structure */
#define D_DEINIT	2
#define	D_PUSH		3	/* 1, 0 */	/* push (stack) */
#define D_INSERT_HEAD	3
#define	D_POP		4	/* 0, 1 */	/* pop (stack) */
#define	D_FIRST		5	/* 0, 1 */	/* read first */
#define D_MIN		5
#define D_INSERT_AFTER	6	/* 2, 0 */
#define D_REMOVE	7	/* 1, 0 */
#define D_HEADPTR	8	/* 0, 1 */
#define D_NEXTPTR	9	/* 1, 1 */
#define D_PTRDATA	10	/* 1, 1 */
#define	D_REMOVE_HEAD	11	/* 0, 0 */
#define D_FOREACH	12	/* 1, 0 */
#define D_INSERT	13	/* 1, 0 */
#define D_ADDKEY	13
#define D_DELETEMIN	14	/* 0, 1 */

#if 0
	D_ACCESS_TAIL,		/* 0, 1 */
	D_INJECT,		/* 1, 0 */
	D_EJECT,		/* 1, 0 */
	D_INSERT_AFTER,		/* 1, 0 */
	D_INSERT_BEFORE,	/* 1, 0 */
	D_DELETE_AFTER,		/* 1, 0 */
	D_DELETE,		/* 1, 0 */
	D_CONCATENATE,		/* 2, 1 */
	D_REVERSE,		/* 0, 0 */
	D_FORWARD_SCAN,		/* 0, 0 */
	D_BACKWARD_SCAN,	/* 0, 0 */
	D_TRAVERSE_PREORDER,	/* 1, 0 */
	D_TRAVERSE_POSTORDER,	/* 1, 0 */
	D_TRAVERSE_INORDER,	/* 1, 0 */
	D_TRAVERSE_BFS,		/* 1, 0 */	/* breadth first */
	D_TRAVERSE_DFS,		/* 1, 0 */	/* depth first */
	D_MAKE_SET,		/* 1, 0 */
	D_FIND_SET,		/* 1, 1 */
	D_LINK_SET,		/* 2, 1 */
	D_DELETE_MIN,		/* 0, 0 */
	D_INSERT,		/* 1, 0 */
	D_MERGE,		/* 2, 1 */
	D_ACCESS,		/* 1, 1 */
	D_JOIN,			/* 3, 1 */
	D_SPLIT,		/* 1, 3 */
	D_FIND_ROOT,		/* 1, 1 */
	D_FIND_COST,		/* 1, 2 */
	D_ADD_COST,		/* 2, 0 */
	D_LINK,			/* 2, 0 */
	D_CUT,			/* 1, 0 */
#endif /* 0 */

/*
 * some defaults provided by the library
 */
extern data_type_t d_int;
int d_nocost(void **);

/*
 * prototypes
 */
data_core_t d_create(char *, data_type_t, int);
void *d_sendevent(data_core_t, int event, ...);
int d_setflags(data_core_t, int);
int d_clearflags(data_core_t, int);

#endif /* _DATA_H_ */
