#ifndef _DATA_SET_H_
#define _DATA_SET_H_

#include <data.h>

#include <stdarg.h>

#define va_ptrarg(ap, type) \
	((void *)((ap) += __va_size(type), (ap) - __va_size(type)))

typedef void *(*data_event_t)(data_core_t core, int event, void *co_arg,
    va_list ap);

struct data_set {
	char	*ds_name;
	int	ds_initsize;
	int	ds_elementsize;
	data_event_t	ds_handler;
};

int roundpow2(int);

void d_copyin(data_core_t, void *src, void *dst);
void d_copydest(data_core_t, void *);
void *d_copyout(data_core_t, void *, int, void *);
void *d_dptr(data_core_t, void *);

#endif /* _DATA_SET_H_ */
