#ifndef _FIB_H_
#define _FIB_H_

typedef int (*void_cmp_fnct)(void *, void *);

struct fib_heap_el;

struct fib_heap {
	void_cmp_fnct	fh_cmp_fnct;
	int	fh_n;
	struct	fib_heap_el *fh_min;
	struct	fib_heap_el *fh_root;
	void	*fh_neginf;
};

struct fib_heap *fh_makeheap(void);
void fh_initheap(struct fib_heap *);
void fh_setcmp(struct fib_heap *, void_cmp_fnct);
void fh_setneginf(struct fib_heap *, void *);
void *fh_insert(struct fib_heap *, void *data);
void *fh_min(struct fib_heap *);
/* this needs to be implemented:
struct fib_heap *fh_union(struct fib_heap *, struct fib_heap *);*/
void *fh_extractmin(struct fib_heap *);
void *fh_replacekey(struct fib_heap *, void *, void *);
void fh_delete(struct fib_heap *, void *);

/*
 * private fib_heap operations
 */
void fh_insertrootlist(struct fib_heap *, struct fib_heap_el *);
void fh_removerootlist(struct fib_heap *, struct fib_heap_el *);
void fh_consolidate(struct fib_heap *);
void fh_heaplink(struct fib_heap *h, struct fib_heap_el *y, struct fib_heap_el *x);
void fh_cut(struct fib_heap *, struct fib_heap_el *, struct fib_heap_el *);
void fh_cascading_cut(struct fib_heap *, struct fib_heap_el *);

struct fib_heap_el {
	int	fhe_degree	: 31;
	int	fhe_mark	: 1;
	struct	fib_heap_el *fhe_p;
	struct	fib_heap_el *fhe_child;
	struct	fib_heap_el *fhe_left;
	struct	fib_heap_el *fhe_right;
	void	*fhe_data;
};

struct fib_heap_el *fhe_newelem(void);
void fhe_initelem(struct fib_heap_el *);
void fhe_setdata(struct fib_heap_el *, void *);
void fhe_insertafter(struct fib_heap_el *a, struct fib_heap_el *b);
void fhe_insertbefore(struct fib_heap_el *a, struct fib_heap_el *b);
void fhe_remove(struct fib_heap_el *a);

#endif /* _FIB_H_ */
